/*.......................................prepar.sas................................*/
/* preparing production file for RR TD model of milk */
filename   prod    "c:\J\pp\GDny\skoleni\blupf90/rrtd/prodrec.prn"; /* raw input file */
filename   record  "c:\J\pp\GDny\skoleni\blupf90/rrtd/record";   /* file for calculation */
data raw ;
	infile prod ;
	input herd $ anim dayr $ monthr $ yearr $ dayc monthc yearc milk ;
htd = compress(herd||dayr||monthr||yearr);		/* herd-test-day*/
drec = dayr*1 + (monthr*1-1)*30 + (yearr*1-1)*365 ;  	/*day of recording */
dbic = dayc + (monthc-1)*30 + (yearc-1)*365 ;  	/*day of calving */
	dim = drec - dbic ;				/* days in milk */
htd = compress(herd|| dayr||monthr||yearr);		/* herd-test-day*/
	proc means ;
/*...............................recoding ............................*/
	proc sort ; by htd;			/* recoding HTDs from 1 */
data a ;						
	set raw ; by htd; if first.htd ;
	keep htd ;
	data b ;					/* code list of HTD */
		set a ;
			nh = _n_ ; 
		proc print ;
	data raw2 ;
	merge raw b ; by htd ;
		keep herd nh anim dim milk ;
	proc means ;
	proc sort ; by anim;			/* recoding cows from 1 */
data a ;						
	set raw2 ; by anim; if first.anim ;
	keep anim ;
	data b ;					/* code list of cows */
		set a ;
			cow = _n_ ; 
		proc print ;
data raw3 ;
	merge raw2 b ; by anim ;		
		keep herd nh cow anim dim milk ;
	proc means ;
	proc freq; tables nh ;
/* ..........................parameters for regressions ...................... */
data regrcov ;				
	set raw3 ;
     sv = 2*((dim-1)/305)-1;							
p1 = sv*sqrt(3);				 p1 = round(p1, .00001);
p2 = 0.5*(3*sv*sv-1)*sqrt(5);	 p2 = round(p2, .00001);
p3 = 0.5*(5*sv**3-3*sv)*sqrt(7); p3 = round(p3, .00001);
	if p1 = 0 then p1= 0.00001 ;
	if p2 = 0 then p2= 0.00001 ;
	if p3 = 0 then p3= 0.00001 ;
		/* residual variances according the parts of lactation*/
v1=8.1205614; v2=4.9632274; v3=3.9800503; v4=4.1415464;
vr = (45*v1+70*v2+150*v3+40*v4)/305; /*average residual variance*/
				/*weights according parts of lactation*/
       if dim <  46 then weight = vr/v1 ;	
else if dim < 116 then weight = vr/v2 ;
else if dim < 266 then weight = vr/v3 ;
else weight = vr/v4 ; 
	weight = round(weight, .00001);
	file record ;
	put herd nh cow anim milk p1 p2 p3 dim weight ;
	proc means;
	/*proc print ;*/
run;/*..............................finish.................*/
