/*................tvor.sas...........*/
/* creation TD for 1 + 3 lactations  */
/*.......................10.6.2014......*/
filename uzit "c:\J\pp\GDny\skoleni\myprog/uzit";
filename prac "c:\J\pp\GDny\skoleni\blupf90/ssg3lb/prac";
filename pro1l"c:\J\pp\GDny\skoleni\blupf90/rrtd/prodrec.prn";
filename prodbl "c:\J\pp\GDny\skoleni\blupf90/ssg3lb/uzit3ss";
filename proddmu "c:\J\pp\GDny\skoleni\dmu/ssg3ld/uzit3ss";
dm output 'clear';
dm log 'clear';
data a;						/* reading 1 lactation 11*/
	infile uzit ;
	input ml anim hys age do   ; 
	daytd = 28 ;		/* recoding every 28. day in month */
mlday1 = ml*0.85/305;	/* production in day lactation 1 15*/
mlday2 = ml/305;
mlday3 = ml*1.1/305;
	if hys <5 then do; yeartd = 2010 ; herd = 1 ; end ;
			  else do; yeartd = 2011 ; herd = 2 ; end ;
	calvd = int(0.5 + 22*ranuni(0));
		if calvd < 1  then calvm = 1 ;
	calvm = int(0.5 + 12*ranuni(0));
		if calvm < 1  then calvm = 1 ;
		if calvm > 12 then calvm = 12 ;
age = age - 28 ;
ci = do + 285 ;
/*.................... 1st lactation......................27*/
proc sort ; by anim;
	proc means ; 				title "input production 29" ;
data prv;						title "days td 30" ;
	set a ;
array kof k1 - k12 ;		/* koefficients lactation curve 32*/
k1=0.7; k2=1.1; k3=1.35; k4=1.45; k5=1.35; k6= 1.15;
k7=1.1; k8=1;   k9=0.6;  k10=0.2; k11=0;   k12=0;
	kk =(k1+k2+k3+k4+k5+k6+k7+k8+k9+k10)/10;
	file prac ;
	konec = 12-calvm+1;
do i = 1 to konec ;
	  mestd = calvm +i-1 ;
	if kof(i) > 0 then do ;
	  ml1 = int(mlday1*kof(i)+rannor(0)*0.5);
	  put herd anim daytd mestd yeartd calvd calvm yeartd ml1 age do ;
	end ;
end ;
	proc means ;
data c;						title "reading days td 1 46" ;
		infile prac ;
	input herd anim daytd mestd yeartd calvd calvm yearot ml1 age do;
	proc means ;
data d1;					title "writted days td 1 lactation 50" ;
	set c ;
if ml1 <= 0 then delete ;
	lact = 1 ;
	age2 = age*age ;
	do = do - 92 ;
	do2 = do*do ;
		file pro1l ;
keep herd anim lact daytd mestd yeartd calvd calvm yearot ml1 age age age2 do do2 ;
put herd anim daytd mestd yeartd calvd calvm yearot ml1 ; /*for only 1. lact 59*/
	proc means;
/* ................animals into 2. lact...................61*/
data e ;
	set d1 ; by anim; if first.anim ;
		keep anim ;
data f ;					title "cows into 2. lact 67" ;
	set e ;
	if rannor(0) > 1 then delete ;
	proc means ;
data dru ;					title "td 2 lact 69" ;
	merge a f(in=dve) ; by anim; if dve ;
	array kof k1 - k12 ;	/* koefficients curve lact 71*/
k1=0.7; k2=1.1; k3=1.35; k4=1.45; k5=1.35; k6= 1.15;
k7=1.1; k8=1;   k9=0.6;  k10=0.2; k11=0;   k12=0;
	kk =(k1+k2+k3+k4+k5+k6+k7+k8+k9+k10)/10;	
	calv2 = (yeartd-1)*365+(calvm-1)*30+calvd +ci;
	yearot2 = int(calv2/365)+1 ;
	calvm2 = int((calv2-(yearot2-1)*365)/30)+1;
	calvd2 = calv2-((yearot2-1)*365+(calvm2-1)*30);
	yeartd2=yearot2;
		konec = 12-calvm2+1;
	file prac ;
do i = 1 to konec ;
	  mestd2 = calvm2 +i-1 ;
	if kof(i) > 0 then do ;
	  ml2 = int(mlday2*kof(i)+rannor(0)*0.5);
	  put herd anim daytd mestd2 yeartd2 calvd2 calvm2 yearot2 ml2 do ci;
	end ;
end ;
	proc means ;
data c;							title "reading days td 2 90" ;
		infile prac ;
	input herd anim daytd mestd yeartd calvd calvm yearot ml2 do ci;
	proc means ;
data d2;						title "writted days td 2 lact 94" ;
	set c ;
if ml2 <= 0 then delete ;
	do = do - 92 ;
	do2 = do*do ;
	ci = ci - 380 ;
	ci2 = ci*ci ;
	lact = 2 ;	
	keep herd anim lact daytd mestd yeartd calvd calvm yearot ml2 do do2 ci ci2;
	proc means;
/* ................cows into 3. lact...................104*/
data e ;
	set d2 ; by anim; if first.anim ;
		keep anim ;
data f ;						title "jcows into 3 lact 108" ;
	set e ;
	if rannor(0) > 1 then delete ;
	proc means ;
data dru ;						title "td 3 lact 112" ;
	merge a f(in=dve) ; by anim; if dve ;
	array kof k1 - k12 ;	/* koefficients curve lact 114*/
k1=0.7; k2=1.1; k3=1.35; k4=1.45; k5=1.35; k6= 1.15;
k7=1.1; k8=1;   k9=0.6;  k10=0.2; k11=0;   k12=0;
	kk =(k1+k2+k3+k4+k5+k6+k7+k8+k9+k10)/10;	
	calv3 = (yeartd-1)*365+(calvm-1)*30+calvd +2*ci;
	yearot3 = int(calv3/365)+1 ;
	calvm3 = int((calv3-(yearot3-1)*365)/30)+1;
	calvd3 = calv3-((yearot3-1)*365+(calvm3-1)*30);
	yeartd3=yearot3;
		konec = 12-calvm3+1;
	file prac ;
do i = 1 to konec ;
	  mestd3 = calvm3 +i-1 ;
	if kof(i) > 0 then do ;
	  ml3 = int(mlday3*kof(i)+rannor(0)*0.5);
	  put herd anim daytd mestd3 yeartd3 calvd3 calvm3 yearot3 ml3 do ci ;
	end ;
end ;
	proc means ;
data c;						title "reading days td 3 133" ;
		infile prac ;
	input herd anim daytd mestd yeartd calvd calvm yearot ml3 do ci ;
	proc means ;
data d3;						title "writted days td 3 lact 137" ;
	set c ;
if ml3 <= 0 then delete ;
	do = do - 92 ;
	do2 = do*do ;
	ci = ci - 380 ;
	ci2 = ci*ci ;	
	lact = 3;	
	keep herd anim lact daytd mestd yeartd calvd calvm yearot ml3 do do2 ci ci2;
	proc means;
/*......................together 1 - 3 ..................147*/
data dooj ;							title "together td 3 lact 148" ;
	set d1 d2 d3 ;
proc means;
/* ........preparing production file for RR TD model of milk.....151 */
data raw ;							title "htd + dim 152" ;
	set dooj ;	
	attrib herdp daytdp mestdp yeartdp format=$5. length=$5;
	attrib htd format=$20. length=$20;
	herdp = herd; daytdp = daytd; mestdp=mestd; yeartdp=yeartd; 
htd = compress(herdp||daytdp||mestdp||yeartdp);		/* herd-test-day 157*/
drec = daytd + (mestd-1)*30 + (yeartd-1)*365 ;  /*day of recording 158*/
dbic = calvd + (calvm-1)*30 + (yearot-1)*365 ;  	/*day of calving 159*/		
	dim = drec - dbic ;				/* days in milk 160*/
	if dim <= 0 then delete ; 		/* if td in day calving 161*/
	proc means ;
/*...............................recoding ............................163*/
	proc sort ; by htd;			/* recoding HTDs from 1 164*/
data a ;						title "htd kod 165" ;
	set raw ; by htd; if first.htd ;
	keep htd ;
data b ;					/* code list of HTD 168*/
	set a ;
		nhtd = _n_ ; 
	proc print ;
data raw2 ;
	merge raw b ; by htd ;
		keep nhtd herd anim dim ml1 ml2 ml3 age age2 do do2 ci ci2  ;
	proc means ;
	proc sort ; by herd;			/* recoding herd from 1 176*/
data a ;						title "herd kod 177" ;
	set raw2 ; by herd; if first.herd ;
	keep herd ;
data b ;					/* code list of herd 180*/
	set a ;
		nsl = _n_ ; 
	proc print ;
data raw3 ;
	merge raw2 b ; by herd;
		keep nhtd nsl anim dim ml1 ml2 ml3 age age2 do do2 ci ci2  ;
	proc means ;
	proc sort ; by anim;			/* recoding cows from 1 188*/
data a ;							title "cow kod 189" ;
	set raw3 ; by anim; if first.anim ;
	keep anim ;
data b ;						/* code list of cows 192*/
	set a ;
		cow = _n_ ; 
	proc print ;
data raw4 ;
	merge raw3 b ; by anim ;		
		keep nhtd nsl cow anim dim ml1 ml2 ml3 age age2 do do2 ci ci2  ;
	proc means ;					title " kody herd 199" ;
	proc freq; tables nh ;
	proc freq; tables nsl ;
/* ..........................parameters for regressions ...................... */
data regrcov ;				title " parametry pro 3 lak RR-TDM 203" ;
	set raw4 ;
     sv = 2*((dim-1)/305)-1;							
p1 = sv*sqrt(3);				 p1 = round(p1, .00001);
p2 = 0.5*(3*sv*sv-1)*sqrt(5);	 p2 = round(p2, .00001);
p3 = 0.5*(5*sv**3-3*sv)*sqrt(7); p3 = round(p3, .00001);
		/* residual variances according the parts of lactation 209*/
v11=8.1205614; v21=4.9632274; v31=3.9800503; v41=4.1415464;
vr1 = (45*v11+70*v21+150*v31+40*v41)/305; /*average residual variance*/
				/*weights according parts of lactation 1 212*/
         if dim <  46 then weight = vr1/v11 ;	
	else if dim < 116 then weight = vr1/v21 ;
	else if dim < 266 then weight = vr1/v31 ;
	else weight = vr1/v41 ;
v12=14.04803; v22=8.6833034; v32=5.5444152; v42=4.3161063;
vr2 = (45*v12+70*v22+150*v32+40*v42)/305; /*average residual variance*/
				/*weights according parts of lactation 2 219*/
         if dim <  46 then weight = vr2/v12 ;	
	else if dim < 116 then weight = vr2/v22 ;
	else if dim < 266 then weight = vr2/v32 ;
	else weight = vr2/v42 ;
v13=17.204321; v23=9.863317; v33=6.2777759; v43=5.1672276;
vr3 = (45*v13+70*v23+150*v33+40*v43)/305; /*average residual variance*/
				/*weights according parts of lactation 3 226*/
         if dim <  46 then weight = vr3/v13 ;	
	else if dim < 116 then weight = vr3/v23 ;
	else if dim < 266 then weight = vr3/v33 ;
	else weight = vr3/v43 ;     
 weight = round(weight, .00001);
 	proc means;
data vse ;			title " writting file for DMU 3 lact RR-TDM 233" ;
	set regrcov ;
		if ml1 = . then ml1 = -999 ;
		if ml2 = . then ml2 = -999 ;
		if ml3 = . then ml3 = -999 ;
	if age  = 0 then age  = 0.001 ;
	if age2 = 0 then age2 = 0.001 ;
	if age  = . then age  = -999 ;
	if age2 = . then age2 = -999 ;
  if do  = 0 then do  = 0.001 ;
  if do2 = 0 then do2 = 0.001 ;
  if do  = . then do  = -999 ;
  if do2 = . then do2 = -999 ;
if ci  = 0 then ci  = 0.001 ;
if ci2 = 0 then ci2 = 0.001 ;
if ci  = . then ci  = -999 ;
if ci2 = . then ci2 = -999 ;
	if p1  = 0 then p1  = 0.00001 ;
	if p2  = 0 then p2  = 0.00001 ;
	if p3  = 0 then p3  = 0.00001 ;
	if p1  = . then p1  = -999 ;
	if p2  = . then p2  = -999 ;
	if p3  = . then p3  = -999 ;
	file proddmu ;
put nhtd nsl cow anim ml1 ml2 ml3 age age2 do do2 ci ci2 p1 p2 p3 dim weight ;
	proc means;
data vse ;			title " writting file for BLUPF90 3 lact RR-TDM 259" ;
	set regrcov ;
		if ml1 = . then ml1 = 0 ;
		if ml2 = . then ml2 = 0 ;
		if ml3 = . then ml3 = 0 ;
	if age  = 0 then age  = 0.001 ;
	if age2 = 0 then age2 = 0.001 ;
	if age  = . then age  = 0 ;
	if age2 = . then age2 = 0 ;
  if do  = 0 then do  = 0.001 ;
  if do2 = 0 then do2 = 0.001 ;
  if do  = . then do  = 0 ;
  if do2 = . then do2 = 0 ;
if ci  = 0 then ci  = 0.001 ;
if ci2 = 0 then ci2 = 0.001 ;
if ci  = . then ci  = 0 ;
if ci2 = . then ci2 = 0 ;
	if p1  = 0 then p1  = 0.00001 ;
	if p2  = 0 then p2  = 0.00001 ;
	if p3  = 0 then p3  = 0.00001 ;
	if p1  = . then p1  = 0 ;
	if p2  = . then p2  = 0 ;
	if p3  = . then p3  = 0 ;
	file prodbl ;
put nhtd nsl cow anim ml1 ml2 ml3 age age2 do do2 ci ci2 p1 p2 p3 dim weight ;
	proc means;	
/*...................cteni.sas...............*/
/*checking data for RR-TDM with 3 lacatations*/
filename prodbl "c:\J\pp\GDny\skoleni\blupf90/ssg3lb/uzit3ss";
dm output 'clear';
dm log 'clear';
data a;									title " all";
	infile prodbl ;
input nh nl cow anim ml1 ml2 ml3 age age2 do do2 ci ci2
		p1 p2 p3 dim weight ;
	If ml1 = 0 then ml1 = . ;
	If ml2 = 0 then ml2 = . ;
	If ml3 = 0 then ml3 = . ;
proc means;
data b;								title " 1 lactation";
	set a ;
		if ml1 = . then delete ;
proc freq; tables nh ;
proc freq; tables nl ;
data b;								title " 2 lactation";
	set a ;
		if ml2 = . then delete ;
proc freq; tables nh ;
proc freq; tables nl ;
data b;								title " 3 lactation";
	set a ;
		if ml3 = . then delete ;
proc freq; tables nh ;
proc freq; tables nl ;
run;/*.............................finish................*/

